#version 330 core
layout (location = 0) in vec3 aPos;
layout(location = 5) in ivec4 boneIds; 
layout(location = 6) in vec4 weights;

//VERTEX SHADER FOR SHADOW MAPPING

uniform mat4 modelMat;

const int MAX_BONES = 100;
const int MAX_BONE_INFLUENCE = 4;
uniform mat4 finalBonesMatrices[MAX_BONES];

void main()
{

mat4 BoneTransform = mat4(0.0f);
	for(int i = 0; i < MAX_BONE_INFLUENCE; i++){
		if(boneIds[i] == -1){
			continue;
		}
		if(boneIds[i] >=MAX_BONES){
			break;
		}
		BoneTransform += finalBonesMatrices[boneIds[i]] * weights[i]; 
	}
	if(BoneTransform == mat4(0.0f)){
		BoneTransform = mat4(1.0f); 
	}

	vec4 PosL = BoneTransform * vec4(aPos,1.0);

	gl_Position = modelMat * PosL;
}  